package mcmultipart.network;

import io.netty.buffer.ByteBuf;
import mcmultipart.item.PartPlacementWrapper;
import mcmultipart.raytrace.RayTraceUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.MovingObjectPosition.MovingObjectType;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;

import net.minecraft.util.MovingObjectPosition.MovingObjectType;
public class MessageWrappedPartPlacement implements IMessage, IMessageHandler<MessageWrappedPartPlacement, MessageWrappedPartPlacement> {

    private String wrapper;

    public MessageWrappedPartPlacement(String handler) {

        this.wrapper = handler;
    }

    public MessageWrappedPartPlacement() {

    }

    @Override
    public void toBytes(ByteBuf buf) {

        ByteBufUtils.writeUTF8String(buf, wrapper);
    }

    @Override
    public void fromBytes(ByteBuf buf) {

        wrapper = ByteBufUtils.readUTF8String(buf);
    }

    @Override
    public MessageWrappedPartPlacement onMessage(final MessageWrappedPartPlacement message, final MessageContext ctx) {

        if (ctx.side == Side.SERVER) {
            MinecraftServer.func_71276_C().func_152344_a(new Runnable() {

                @Override
                public void run() {

                    MessageWrappedPartPlacement.handlePacket(message, ctx.getServerHandler().field_147369_b);
                }
            });
        }
        return null;
    }

    private static void handlePacket(MessageWrappedPartPlacement message, EntityPlayer player) {

        World world = player.field_70170_p;
        MovingObjectPosition mop = world.func_72933_a(RayTraceUtils.getStart(player), RayTraceUtils.getEnd(player));
        if (mop == null || mop.field_72313_a != MovingObjectType.BLOCK) return;
        BlockPos pos = mop.func_178782_a();
        EnumFacing side = mop.field_178784_b;
        Vec3 hit = mop.field_72307_f.func_178788_d(new Vec3(mop.func_178782_a()));
        ItemStack stack = player.func_71045_bC();

        if (PartPlacementWrapper.getWrapper(message.wrapper).doPlace(world, pos, side, hit, stack, player)) player.func_71038_i();
    }

    public void send() {

        MultipartNetworkHandler.sendToServer(this);
    }

}
